Attribute VB_Name = "apci33w"
'*****************************************************************************
'*                                                                           *
'* aPCI-P33                                                             *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 1999/05/27                                                           *
'*                                                                           *
'*****************************************************************************
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const APCI33_DLL_NAME = "apci33.dll" ' DLL
Global Const APCI33_ERR_WRAPDLL = -1        ' bp[֐G[

Dim hDLL As Long                'DLLւ

'*****************************************************************************
'*    apci33.dll۰(۰ގʹװƂ)                          *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci33wDllOpen() As Boolean

    Apci33wDllOpen = False

    If hDLL <> 0 Then Exit Function

    hDLL = LoadLibrary(APCI33_DLL_NAME)
    If hDLL = 0 Then Exit Function
    
    If Apci33wGetDllExportFunc() = False Then
        Apci33wDllClose     ' DLL֐擾ɎŝDLL۰
        Exit Function
    End If

    Apci33wDllOpen = True

End Function

'*****************************************************************************
'*    apci33.dll۰(۰ގʹװƂ)                      *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci33wDllClose() As Boolean

    Apci33wDllClose = True

    If hDLL = 0 Then Exit Function

    If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Apci33wDllClose = False

End Function

'*****************************************************************************
'*    aPCI-P33 DLL,޲ײްްޮݔԍ擾                        *
'*    pdwDllVersion    DLLްޮݔԍi[                              *
'*        pdwDriverVersion ޲ײްްޮݔԍi[                    *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci33wGetVersion(pdwDllVersion As Long, pdwDriverVersion As Long) As Boolean

    Apci33wGetVersion = False
    If hDLL <> 0 Then
        If Apci33GetVersion(pdwDllVersion, pdwDriverVersion) <> 0 Then
            Apci33wGetVersion = True
        End If
    End If

End Function

'*****************************************************************************
'*    aPCI-P33̔Cӂ޲̎gp錾                                 *
'*    pwLogSlot  gp޲̘_ۯĔԍi[                      *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci33wCreate(pwLogSlot As Integer) As Boolean

    Apci33wCreate = False
    If hDLL <> 0 Then
        If Apci33Create(pwLogSlot) <> 0 Then
            Apci33wCreate = True
        End If
    End If

End Function

'*****************************************************************************
'*    aPCI-P33̔Cӂ޲̎gpJ                                 *
'*    wLogSlot ޲̘_ۯĔԍ                              *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci33wClose(wLogSlot As Integer) As Boolean

    Apci33wClose = False
    If hDLL <> 0 Then
        If Apci33Close(wLogSlot) <> 0 Then
            Apci33wClose = True
        End If
    End If

End Function

'*****************************************************************************
'*    w޲ؿ擾                                         *
'*    wLogSlot ؿ擾޲̘_ۯĔԍ                    *
'*        pResInfo ؿi[\                                  *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci33wGetResource(wLogSlot As Integer, pResInfo As APCI33RESOURCE) As Boolean

    Apci33wGetResource = False
    If hDLL <> 0 Then
        If Apci33GetResource(wLogSlot, pResInfo) <> 0 Then
            Apci33wGetResource = True
        End If
    End If

End Function

'*****************************************************************************
'*    ۰ذ̒l擾                                                *
'*    wLogSlot       ۰ذ̒l擾޲̘_ۯĔԍ         *
'*    pdwSwitchValue ۰ذ̒li[                                 *
'* ߂l  TRUE                                                          *
'*        s FALSE                                                         *
'*****************************************************************************
Function Apci33wGetSwitchValue(wLogSlot As Integer, pdwSwitchValue As Long) As Boolean

    Apci33wGetSwitchValue = False
    If hDLL <> 0 Then
        If Apci33GetSwitchValue(wLogSlot, pdwSwitchValue) <> 0 Then
            Apci33wGetSwitchValue = True
        End If
    End If

End Function

'*****************************************************************************
'*    Cӂ߰Ăްo                                             *
'*    wLogSlot  o͂޲̘_ۯĔԍ                             *
'*        dwLogPort o͂_߰                                         *
'*        bOutValue o͂ް                                             *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci33wOutPort(wLogSlot As Integer, dwLogPort As Long, bOutValue As Byte) As Boolean

    Apci33wOutPort = False
    If hDLL <> 0 Then
        If Apci33OutPort(wLogSlot, dwLogPort, bOutValue) <> 0 Then
            Apci33wOutPort = True
        End If
    End If

End Function

'*****************************************************************************
'*    aPCI-P33̴װ                                                  *
'*    wLogSlot  װ޲̘_ۯĔԍ                        *
'* ߂l װ                                                            *
'*****************************************************************************
Function Apci33wGetLastError(wLogSlot As Integer) As Long

    If hDLL = 0 Then
        Apci33wGetLastError = APCI33_ERR_WRAPDLL
        Exit Function
    End If

    Apci33wGetLastError = Apci33GetLastError(wLogSlot)

End Function

'*---------------------------------------------------------------------------*
'*    DLL߰Ċ֐ڽ̎擾                                          *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*---------------------------------------------------------------------------*
Private Function Apci33wGetDllExportFunc() As Boolean

    Dim pFunc As Long
    
    Apci33wGetDllExportFunc = False
    
    ' Apci33GetVersion ̱ڽ擾
    pFunc = GetProcAddress(hDLL, "Apci33GetVersion")
    If pFunc = 0 Then Exit Function

    ' Apci33Create ̱ڽ擾
    pFunc = GetProcAddress(hDLL, "Apci33Create")
    If pFunc = 0 Then Exit Function

    ' Apci33Close ̱ڽ擾
    pFunc = GetProcAddress(hDLL, "Apci33Close")
    If pFunc = 0 Then Exit Function

    ' Apci33GetResource ̱ڽ擾
    pFunc = GetProcAddress(hDLL, "Apci33GetResource")
    If pFunc = 0 Then Exit Function

    ' Apci33OutPort ̱ڽ擾
    pFunc = GetProcAddress(hDLL, "Apci33OutPort")
    If pFunc = 0 Then Exit Function

    ' Apci33GetLastError ̱ڽ擾
    pFunc = GetProcAddress(hDLL, "Apci33GetLastError")
    If pFunc = 0 Then Exit Function

    ' Apci33GetSwitchValue ̱ڽ擾
    pFunc = GetProcAddress(hDLL, "Apci33GetSwitchValue")
    If pFunc = 0 Then Exit Function

    Apci33wGetDllExportFunc = True  ' SĂ DLL ߰Ċ֐ڽ擾

End Function

